/*
 *	 /usr/devel/include/libdbd.h
 *	 Generated by sql2class by (C) AH 2000
 *	 Thu May 27 14:10:44 2004
 */

/*
Copyright (C) 2001  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _LIBDBD_H
#define _LIBDBD_H

#ifdef _WIN32
#define strncasecmp strnicmp
#define strcasecmp stricmp
#endif // _WIN32

/**
 **  Class 'Access' and 'cAccess'
 **/

namespace db
{
class Access {
public:
	Access(Database *);
	Access(Database *,long);
	Access(Database *,const std::string& );
	Access(Database *,Query *);
	~Access();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long usernum;
	long dbnum;
	long r;
	long w;
	long c;
	long d;
	long rdata;
	long wdata;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Access'

} // end of namespace

/**
 **  Class 'Appfields' and 'cAppfields'
 **/

namespace db
{
class Appfields {
public:
	Appfields(Database *);
	Appfields(Database *,long);
	Appfields(Database *,const std::string& );
	Appfields(Database *,Query *);
	~Appfields();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long appnum;
	long fldnum;
	char status[37];
	long tblnum;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Appfields'

} // end of namespace

/**
 **  Class 'Applications' and 'cApplications'
 **/

namespace db
{
class Applications {
public:
	Applications(Database *);
	Applications(Database *,long);
	Applications(Database *,const std::string& );
	Applications(Database *,Query *);
	~Applications();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long owner;
	char createdate[41];
	long changedby;
	char changedate[41];
	long deleted;
	long deletedby;
	char deletedate[41];
	char name[41];
	long version;
	long dbnum;
	char description[41];

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Applications'

} // end of namespace

/**
 **  Class 'Apptables' and 'cApptables'
 **/

namespace db
{
class Apptables {
public:
	Apptables(Database *);
	Apptables(Database *,long);
	Apptables(Database *,const std::string& );
	Apptables(Database *,Query *);
	~Apptables();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long appnum;
	long tblnum;
	long checked;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Apptables'

} // end of namespace

/**
 **  Class 'Appusers' and 'cAppusers'
 **/

namespace db
{
class Appusers {
public:
	Appusers(Database *);
	Appusers(Database *,long);
	Appusers(Database *,const std::string& );
	Appusers(Database *,Query *);
	~Appusers();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long appnum;
	long usernum;
	char status[27];

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Appusers'

} // end of namespace

/**
 **  Class 'Dbs' and 'cDbs'
 **/

namespace db
{
class Dbs {
public:
	Dbs(Database *);
	Dbs(Database *,long);
	Dbs(Database *,const std::string& );
	Dbs(Database *,Query *);
	~Dbs();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long owner;
	char createdate[41];
	long changedby;
	char changedate[41];
	long deleted;
	long deletedby;
	char deletedate[41];
	char name[41];
	long version;
	char description[81];

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Dbs'

} // end of namespace

/**
 **  Class 'Flds' and 'cFlds'
 **/

namespace db
{
class Flds {
public:
	Flds(Database *);
	Flds(Database *,long);
	Flds(Database *,const std::string& );
	Flds(Database *,Query *);
	~Flds();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long tblnum;
	long owner;
	char createdate[41];
	long changedby;
	char changedate[41];
	long deleted;
	long deletedby;
	char deletedate[41];
	char name[41];
	long version;
	long fieldtype;
	long charlength;
	long minvalue;
	long maxvalue;
	char *options;
	long ptrtotblnum;
	long ordning;
	long integerlength;
	char description[81];
	char fieldstr[21];
	long fieldflags;
	long decimallength;
	char defaultvalue[41];

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Flds'

} // end of namespace

/**
 **  Class 'Grplinks' and 'cGrplinks'
 **/

namespace db
{
class Grplinks {
public:
	Grplinks(Database *);
	Grplinks(Database *,long);
	Grplinks(Database *,const std::string& );
	Grplinks(Database *,Query *);
	~Grplinks();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long usernum;
	long grpnum;
	long dbnum;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Grplinks'

} // end of namespace

/**
 **  Class 'Grps' and 'cGrps'
 **/

namespace db
{
class Grps {
public:
	Grps(Database *);
	Grps(Database *,long);
	Grps(Database *,const std::string& );
	Grps(Database *,Query *);
	~Grps();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	char name[41];
	long usernum;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Grps'

} // end of namespace

/**
 **  Class 'Indexlist' and 'cIndexlist'
 **/

namespace db
{
class Indexlist {
public:
	Indexlist(Database *);
	Indexlist(Database *,long);
	Indexlist(Database *,const std::string& );
	Indexlist(Database *,Query *);
	~Indexlist();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long indexnum;
	long fldnum;
	long length;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Indexlist'

} // end of namespace

/**
 **  Class 'Indexs' and 'cIndexs'
 **/

namespace db
{
class Indexs {
public:
	Indexs(Database *);
	Indexs(Database *,long);
	Indexs(Database *,const std::string& );
	Indexs(Database *,Query *);
	~Indexs();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long owner;
	char createdate[41];
	long changedby;
	char changedate[41];
	long deleted;
	long deletedby;
	char deletedate[41];
	char name[41];
	long version;
	long tblnum;
	char typ[44];
	char description[41];

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Indexs'

} // end of namespace

/**
 **  Class 'Kommentar' and 'cKommentar'
 **/

namespace db
{
class Kommentar {
public:
	Kommentar(Database *);
	Kommentar(Database *,long);
	Kommentar(Database *,const std::string& );
	Kommentar(Database *,Query *);
	~Kommentar();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long dbnum;
	long tblnum;
	long fldnum;
	long usernum;
	char dateposted[41];
	char reason[81];
	char *kommentar;
	long indexnum;
	long appnum;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Kommentar'

} // end of namespace

/**
 **  Class 'Tblgrps' and 'cTblgrps'
 **/

namespace db
{
class Tblgrps {
public:
	Tblgrps(Database *);
	Tblgrps(Database *,long);
	Tblgrps(Database *,const std::string& );
	Tblgrps(Database *,Query *);
	~Tblgrps();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	char name[41];
	long dbnum;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Tblgrps'

} // end of namespace

/**
 **  Class 'Tbls' and 'cTbls'
 **/

namespace db
{
class Tbls {
public:
	Tbls(Database *);
	Tbls(Database *,long);
	Tbls(Database *,const std::string& );
	Tbls(Database *,Query *);
	~Tbls();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long dbnum;
	long owner;
	char createdate[41];
	long changedby;
	char changedate[41];
	long deleted;
	long deletedby;
	char deletedate[41];
	char name[41];
	long version;
	char description[81];
	long tblgrpnum;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Tbls'

} // end of namespace

/**
 **  Class 'Users' and 'cUsers'
 **/

namespace db
{
class Users {
public:
	Users(Database *);
	Users(Database *,long);
	Users(Database *,const std::string& );
	Users(Database *,Query *);
	~Users();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	char handle[21];
	char name[41];
	char password[21];
	long superuser;
	char email[61];
	char icq[21];
	char prevdatum[41];
	char thisdatum[41];
	long maxdbs;
	long maxtbls;
	long maxflds;
	long flags;
	long steps;
	long maxindexs;
	long maxapps;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Users'

} // end of namespace

/**
 **  Class 'Valid' and 'cValid'
 **/

namespace db
{
class Valid {
public:
	Valid(Database *);
	Valid(Database *,long);
	Valid(Database *,const std::string& );
	Valid(Database *,Query *);
	~Valid();
	void select(const std::string& );
	long insert();
	void update();
	void update(long);
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	int num_cols();

	long num;
	long usernum;
	long valid;

private:
	Database *database;
	short new_object;
	void clear();
	void spawn(const std::string& );
	void spawn(Query *);
}; // End of class 'Valid'

} // end of namespace
#endif // _LIBDBD_H
